<template>
  <div class="d-flex flex-column">
    <div class="row">
      <div class="col-12">
        <div class="card card-rounded card-flush mb-5 shadow-sm">
          <div class="card-body p-2">
            <GoogleMap
              api-key="AIzaSyA2XeZf5gGUwUTKl9y-hq2GsMdTlCJCgds"
              style="height: 300px"
              :center="{lat: sVenta.latitud, lng: sVenta.longitud}"
              :zoom="9"
            >
              <Marker
                v-for="venta in pVentas"
                :key="venta.id"
                :options="{ position: {lat: venta.latitud, lng: venta.longitud}, draggable: false, clickable: true }"
              >
                <InfoWindow>
                  <div id="contet">
                    <div id="siteNotice">
                      <img
                        :src="venta.imagen"
                        class="img-fluid h-100px"
                        alt="imagen"
                      >
                    </div>
                    <h1
                      id="firstHeading"
                      class="firstHeading"
                      v-text="'Publicación N° ' + venta.id"
                    />
                    <div id="bodyContent d-flex flex-column">
                      <p class="fs-6 fw-bolder text-gray-900">
                        Publicado: <span
                          class="fs-6 fw-normal text-gray-600"
                          v-text="venta.fechaHoraRegistrado"
                        />
                      </p>
                      <p class="fs-6 fw-bolder text-gray-900">
                        Cabezas: <span
                          class="fs-6 fw-normal text-gray-600"
                          v-text="venta.cantidadEspecie"
                        />
                      </p>
                      <p class="fs-6 fw-bolder text-gray-900">
                        Peso promedio: <span
                          class="fs-6 fw-normal text-gray-600"
                          v-text="venta.pesoPromedio + ' Kg'"
                        />
                      </p>
                      <p class="fs-6 fw-bolder text-gray-900">
                        Precio: <span
                          class="fs-6 fw-normal text-gray-600"
                          v-text="venta.precioPreferencial + ' BOB'"
                        />
                      </p>
                      <p>
                        <router-link :to="{ name: 'panel.venta.mostrar', params: { id: venta.id }}">
                          más detalle
                        </router-link>
                      </p>
                    </div>
                  </div>
                </InfoWindow>
              </Marker>
            </GoogleMap>
          </div>
        </div>
      </div>
    </div>

    <div class="row mb-0">
      <div class="col-12">
        <div class="card card-flush mb-5 mb-xl-8 mt-5 p-5 shadow-sm">
          <paginacion
            ref="tablaPublicacionBuscarPaginacion"
            :cantidades="[4,8,12,16]"
            :datos="ventas"
            @on-mostrar-pagina="onMostrarPagina"
          />
        </div>
      </div>
    </div>
    <div class="row mt-0">
      <div
        v-if="responseListar === 'LOADING'"
        class="d-flex justify-content-center py-20"
      >
        <div
          class="spinner-border text-primary"
          style="width: 4rem; height: 4rem; border-width: 0.35rem"
          role="status"
        >
          <span class="visually-hidden">Cargando...</span>
        </div>
      </div>

      <div
        v-for="venta in pVentas"
        v-else
        :key="venta.id"
        class="col-12 col-md-6 col-lg-3 mt-2"
      >
        <div
          class="card bg-hover-light text-hover-inverse-light shadow-sm"
          @click="onSeleccionarPublicacionMapa(venta)"
        >
          <img
            :src="venta.imagen"
            class="card-img-top h-150px"
            alt="imagen"
          >
          <div class="card-body d-flex flex-column p-2">
            <label class="fs-6 fw-bolder text-gray-900">Publicado: <span
              class="fs-6 fw-normal text-gray-600"
              v-text="venta.fechaHoraRegistrado"
            /></label>
            <label class="fs-6 fw-bolder text-gray-900">Cabezas: <span
              class="fs-6 fw-normal text-gray-600"
              v-text="venta.cantidadEspecie"
            /></label>
            <label class="fs-6 fw-bolder text-gray-900">Peso promedio: <span
              class="fs-6 fw-normal text-gray-600"
              v-text="venta.pesoPromedio + ' Kg'"
            /></label>
            <label class="fs-6 fw-bolder text-gray-900">Precio: <span
              class="fs-6 fw-normal text-gray-600"
              v-text="venta.precioPreferencial + ' BOB'"
            /></label>
            <router-link
              :to="{ name: 'panel.venta.mostrar', params: { id: venta.id }}"
              class="btn btn-primary"
            >
              Detalle
            </router-link>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import Paginacion from "@/components/util/Paginacion2";
import { GoogleMap, Marker, InfoWindow  } from "vue3-google-map";

export default {
  name: 'TablaVentaBuscar',
  components: {
    GoogleMap, Marker, InfoWindow, Paginacion
  },
  props: {
    ventas: {type: Array, required: true},
    responseListar: {type: String, required: true, default: 'LOADING'}
  },
  data() {
    return {
      sVenta: {latitud: -17.783602, longitud: -63.182327},
      pVentas: []
    }
  },
  methods: {
    onMostrarPagina(datos) {
      this.pVentas = datos;
      if(this.pVentas.length > 0) {
        this.sVenta = this.pVentas[0];
      } else {
        this.sVenta = {latitud: -17.783602, longitud: -63.182327};
      }
    },

    onSeleccionarPublicacionMapa(publicacion) {
      this.sVenta = publicacion;
    }
  },
}

</script>